#include <sys/types.h>
#include <sys/stat.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>

#include "gtkplot.h"

#include "app.h"
#include "prefs.h"
#include "stringfuncs.h"


struct prefs prf; /* Define the prefs struct. this is used globally. */


static char *get_config_path();

GdkColormap *colormap;

extern GtkWidget *window1;




void defaults (void)
{
  /* First set up the color defaults. The defaults are stored as names and therefor need translation. */

  /*colormap = gdk_window_get_colormap (window1);

  gdk_color_parse(PREFS_DEFAULT_COLOR0, &prf.color[0]);
  gdk_color_alloc(colormap, &prf.color[0]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR1, &prf.color[1]);
  gdk_color_alloc(colormap, &prf.color[1]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR2, &prf.color[2]);
  gdk_color_alloc(colormap, &prf.color[2]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR3, &prf.color[3]);
  gdk_color_alloc(colormap, &prf.color[3]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR4, &prf.color[4]);
  gdk_color_alloc(colormap, &prf.color[4]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR5, &prf.color[5]);
  gdk_color_alloc(colormap, &prf.color[5]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR6, &prf.color[6]);
  gdk_color_alloc(colormap, &prf.color[6]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR7, &prf.color[7]);
  gdk_color_alloc(colormap, &prf.color[7]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR8, &prf.color[8]);
  gdk_color_alloc(colormap, &prf.color[8]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR9, &prf.color[9]);
  gdk_color_alloc(colormap, &prf.color[9]);
  
  gdk_color_parse(PREFS_DEFAULT_BGCOLOR, &prf.bgcolor);
  gdk_color_alloc(colormap, &prf.bgcolor);
  
  gdk_color_parse(PREFS_DEFAULT_GRIDCOLOR, &prf.gridcolor);
  gdk_color_alloc(colormap, &prf.gridcolor); */



  
  gdk_color_parse(PREFS_DEFAULT_COLOR0, &prf.color[0]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[0]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR1, &prf.color[1]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[1]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR2, &prf.color[2]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[2]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR3, &prf.color[3]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[3]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR4, &prf.color[4]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[4]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR5, &prf.color[5]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[5]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR6, &prf.color[6]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[6]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR7, &prf.color[7]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[7]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR8, &prf.color[8]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[8]);
  
  gdk_color_parse(PREFS_DEFAULT_COLOR9, &prf.color[9]);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.color[9]);
  
  gdk_color_parse(PREFS_DEFAULT_BGCOLOR, &prf.bgcolor);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.bgcolor);
  
  gdk_color_parse(PREFS_DEFAULT_GRIDCOLOR, &prf.gridcolor);
  gdk_color_alloc(gdk_colormap_get_system(), &prf.gridcolor);
  
  
  /* Set booleans to defaults */
  
  prf.showgrid = PREFS_DEFAULT_SHOWGRID;
  prf.showlegend = PREFS_DEFAULT_SHOWLEGEND;

  prf.showtop = PREFS_DEFAULT_SHOWTOP;
  prf.showbottom = PREFS_DEFAULT_SHOWBOTTOM;
  prf.showleft = PREFS_DEFAULT_SHOWLEFT;
  prf.showright = PREFS_DEFAULT_SHOWRIGHT;
  prf.showxy = PREFS_DEFAULT_SHOWXY;
}


static gchar eoln = '\n';
static gchar comment = '#';


int prefs_save(void)
{
   FILE *fp;
   
   fp = fopen(get_config_path(), "w");
   if (fp == NULL)
     {
       //ERROR
       return 0;
     }
   
   fprintf(fp, "%c This is the GtkGraph initialization file.\n", comment);
   fprintf(fp, "%c Lines that start with a '%c' are comments.\n", comment, comment);
   fprintf(fp, "%c Blank lines are ignored.\n\n", comment);
   
   fprintf(fp, "%c Set the color information for the plots\n", comment);
   fprintf(fp, "color %x:%x:%x %x:%x:%x %x:%x:%x %x:%x:%x %x:%x:%x %x:%x:%x %x:%x:%x %x:%x:%x %x:%x:%x %x:%x:%x\n",                    prf.color[0].red,
	                                                prf.color[0].green,
                                                        prf.color[0].blue,
                                                        prf.color[1].red,
	                                                prf.color[1].green,
                                                        prf.color[1].blue,
	                                                prf.color[2].red,
	                                                prf.color[2].green,
                                                        prf.color[2].blue,
                                                        prf.color[3].red,
	                                                prf.color[3].green,
                                                        prf.color[3].blue,
                                                        prf.color[4].red,
	                                                prf.color[4].green,
                                                        prf.color[4].blue,
                                                        prf.color[5].red,
	                                                prf.color[5].green,
                                                        prf.color[5].blue,
                                                        prf.color[6].red,
	                                                prf.color[6].green,
                                                        prf.color[6].blue,
                                                        prf.color[7].red,
	                                                prf.color[7].green,
                                                        prf.color[7].blue,
                                                        prf.color[8].red,
	                                                prf.color[8].green,
                                                        prf.color[8].blue,
                                                        prf.color[9].red,
	                                                prf.color[9].green,
                                                        prf.color[9].blue     );


   fprintf (fp, "legend %i\n", prf.showlegend);

   fprintf (fp, "%c End of GtkGraph initialization file.", comment);

   fclose(fp);

   chmod(get_config_path(), 00600);

   return (1);
}


int prefs_read(void)
{
   FILE *fp;
   gchar buffer[256];
   int i, colornum=0, channum=0;
   extern GtkPlotData *dataset[10];

   fp = fopen(get_config_path(), "r");
   if (fp == NULL)
     {
       //ERROR
       return 0;
     }

   while (!feof(fp))
     {
       fgets(buffer, 256, fp);
       trim_leadspc(buffer);
       if (buffer[0] != eoln && buffer[0] != comment)
	 {
	   /* now we know to parse for variables */
	   if (!strncmp("color", buffer, strlen("color")))
	     {
	       remove_string(buffer, 0, strlen("color"));

	       for (i=0; buffer[i] != 0; ++i)
		 {
		   if (buffer[i] == ' ' || buffer[i] == ':')
		     {
		       if (channum == 0)
			 {
			   gdk_colormap_free_colors (gdk_colormap_get_system(), &prf.color[colornum], 1);
			 }
		       buffer[i] = ' ';

		       switch (channum)
			 {
			   case 0:
			     prf.color[colornum].red = strtol (&buffer[i], (char **)NULL, 16);
			     break;
			   case 1:
			     prf.color[colornum].green = strtol (&buffer[i], (char **)NULL, 16);
			     break;
 			   case 2:
			     prf.color[colornum].blue = strtol (&buffer[i], (char **)NULL, 16);
			     break;
			 }

		       if (channum == 2)
			 {
			   channum = 0;
			   gdk_color_alloc(gdk_colormap_get_system(), &prf.color[colornum]);
			   gtk_plot_dataset_set_line_attributes(dataset[colornum],
								GTK_PLOT_LINE_SOLID,
								0, prf.color[colornum]);
			   /*gdk_color_change (gdk_colormap_get_system(), &prf.color[colornum]);*/
			   ++colornum;
			 }
		       else              { ++channum;               }
		     }
		 }
	     }
	   else if (!strncmp("legend", buffer, strlen("legend")))
	     {
	       remove_string(buffer, 0, strlen("legend"));
	       trim_leadspc (buffer);
	       if (buffer[0] == '1')
		 prf.showlegend = 1;
	       else if (buffer[0] == '0')
		 prf.showlegend = 0;
	       else
		 return (0);
	     }
	 }
     }
   return 1;
}

static char *get_config_path()
{
  char *home_dir;
  unsigned int home_dir_len;
  char *buffer;
  home_dir_len = strlen(getenv("HOME"));
  home_dir = malloc(home_dir_len + 1);
  strcpy(home_dir, getenv("HOME"));
  buffer = malloc(home_dir_len + 1 + strlen("/.gtkgraphrc") + 1);
  sprintf(buffer, "%s/%s", home_dir, "/.gtkgraphrc");
  return buffer;
}
